use serde::{Deserialize, Serialize};

#[derive(Serialize, Deserialize)]
pub struct EventData {}

#[derive(Serialize, Deserialize)]
pub struct Event {
    #[serde(rename = "eventId")]
    pub event_id: String,
    #[serde(rename = "eventType")]
    pub event_type: i32,
    #[serde(rename = "happenTime")]
    pub happen_time: String,
    #[serde(rename = "srcIndex")]
    pub src_index: String,
    #[serde(rename = "srcName")]
    pub src_name: Option<String>,
    #[serde(rename = "srcParentIndex")]
    pub src_parent_index: Option<String>,
    #[serde(rename = "srcType")]
    pub src_type: String,
    pub status: i64,
    #[serde(rename = "eventLvl")]
    pub event_lvl: Option<i64>,
    pub timeout: i64,
    pub data: Option<EventData>,
}

#[derive(Serialize, Deserialize)]
pub struct Params {
    #[serde(rename = "sendTime")]
    pub send_time: String,
    pub ability: String,
    pub uids: Option<String>,
    pub events: Vec<Event>,
}

#[derive(Serialize, Deserialize)]
pub struct EventMessage {
    pub method: String,
    pub params: Params,
}
